/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is
 * Henrik Gemal http://gemal.dk
 *
 * Portions created by the Initial Developer are Copyright (C) 2001-2005
 * the Initial Developer. All Rights Reserved.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gLaunchyApps = null;
var gLaunchyAppsList = null;
var LaunchyContext;
var gLaunchyFirefox = 0;

var _elementIDs = ["launchydeveloper", "launchyautodetectapps", "launchyshowfileicons"];

function onLoad() {
	if (typeof(parent.initPanel) != "undefined") {
		// Mozilla 1.x pref init
		parent.initPanel(window.location.href);
	} else if (typeof(window.opener.top.initPanel) != "undefined") {
		// Mozilla Firebird pref init
		window.opener.top.initPanel(window.location.href, window);
	} else {
		// Mozilla Firefox pref init
		gLaunchyFirefox = 1;
		Startup();
		loadPref();
	}
}

function loadPref() {
	for (var i = 0; i < _elementIDs.length; i++) {
		var did = document.getElementById(_elementIDs[i]);
		var prefname = did.getAttribute("prefstring");
		var prefvalue;
		try {
			prefvalue = LaunchyContext.pref.getBoolPref(prefname);
		} catch(ex) {
			prefvalue = false;
		}
		did.checked = prefvalue;
	}
}

function savePref() {
	for (var i = 0; i < _elementIDs.length; i++) {
		var did = document.getElementById(_elementIDs[i]);
		var prefname = did.getAttribute("prefstring");
		var prefvalue = did.checked;
		launchyShared.trace("Setting pref <" + prefname + "> to <" + prefvalue + ">");
		LaunchyContext.pref.setBoolPref(prefname, prefvalue);
		switch (prefname) {
			case "extensions.launchy.showfileicons":
				LaunchyContext.showfileicons = prefvalue;
				break;
			case "extensions.launchy.developer":
				LaunchyContext.developer = prefvalue;
				break;
			default:
				launchyShared.trace("argh: " + prefname);
				break;
		}
	}
}

function Startup() {
	var ass = Components.classes["@mozilla.org/appshell/appShellService;1"].getService(Components.interfaces.nsIAppShellService);
	var w = ass.hiddenDOMWindow;
	LaunchyContext = w.launchy;

	var did = document.getElementById("launchy-location");
	if (did) {
		var chromedir = Launchy_DirIO.get("AChrom");
		chromedir.append("launchy.jar");
		var jarfile = chromedir.path;
		var f = Launchy_FileIO.open(jarfile);
		if (f && f.exists()) {
			did.setAttribute("hidden", false);
			document.getElementById("launchy-location-path").setAttribute("value", ld);
		} else {
			chromedir = Launchy_DirIO.get("UChrm");
			chromedir.append("launchy.jar");
			jarfile = chromedir.path;
			f = Launchy_FileIO.open(jarfile);
			if (f && f.exists()) {
				did.setAttribute("hidden", false);
				document.getElementById("launchy-location-path").setAttribute("value", ld);
			}
		}
	}

	did = document.getElementById("launchy-xmlfile");
	if (did) {
		if (typeof(LaunchyContext.xmlfile) != "undefined") {
			did.setAttribute("hidden", false);
			document.getElementById("launchy-xmlfile-location-path").setAttribute("value", LaunchyContext.xmlfile);
		} else {
			document.getElementById("launchy-xmlfile-no").setAttribute("hidden", false);
			chromedir = Launchy_DirIO.get("UChrm");
			document.getElementById("launchy-xmlfile-no-path").setAttribute("value", chromedir.path);
		}
	}

	did = document.getElementById("launchyAppsList");
	if (did) {
		gLaunchyApps = new LaunchyApps();
		gLaunchyAppsList = did;
		gLaunchyAppsList.treeBoxObject.view = gLaunchyApps;
	}
}

function onOK() {
	// regenerate apps
	LaunchyContext.apps = new Array();
	LaunchyContext.appsdisabled = new Array();

	var disabled = "";
	for (var i = 0; i < gLaunchyApps._LaunchyApps.length; ++i) {
		if (gLaunchyApps._LaunchyApps[i].enabled == 1) {
			LaunchyContext.apps[LaunchyContext.apps.length] = gLaunchyApps._LaunchyApps[i];
		} else if (gLaunchyApps._LaunchyApps[i].enabled == 2) {
			disabled += gLaunchyApps._LaunchyApps[i].name + ",";
			LaunchyContext.appsdisabled[LaunchyContext.appsdisabled.length] = gLaunchyApps._LaunchyApps[i];
		}
	}
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	if (disabled != "") {
		disabled = disabled.substr(0, disabled.length - 1);
		pref.setCharPref("extensions.launchy.disabledapps", disabled);
		launchyShared.trace("<extensions.launchy.disabledapps> pref set to <" + disabled + ">");
	}	else if (pref.prefHasUserValue("extensions.launchy.disabledapps")) {
		pref.clearUserPref("extensions.launchy.disabledapps");
		launchyShared.trace("clearing <extensions.launchy.disabledapps> pref");
	}

	try {
		if (typeof(window.opener.top.hPrefWindow) != "undefined") {
			window.opener.top.hPrefWindow.wsm.savePageData(window.location.href, window);
		}
	} catch(ex) {
	}

	// HACK - if this is Firefox we need to handle the saving of prefs ourself
	if (gLaunchyFirefox) {
		savePref();
	}

	return true;
}

function GetTreeSelections(tree) {
	var selections = [];
	var select = tree.view.selection;
	if (select) {
		var count = select.getRangeCount();
		var min = new Object();
		var max = new Object();
		for (var i=0; i<count; i++) {
			select.getRangeAt(i, min, max);
			for (var k=min.value; k<=max.value; k++) {
				if (k != -1) {
					selections[selections.length] = k;
				}
			}
		}
	}
	return selections;
}

function LaunchyAppSelected() {
	var selections = GetTreeSelections(gLaunchyAppsList);

	var idx = selections[0];
	var props = [
		{id: "launchy-apps-info-name", value: gLaunchyApps._LaunchyApps[idx].name},
		{id: "launchy-apps-info-type", value: LaunchyContext.appstype[gLaunchyApps._LaunchyApps[idx].type]},
		{id: "launchy-apps-info-exe", value: gLaunchyApps._LaunchyApps[idx].exe},
		{id: "launchy-apps-info-args", value: gLaunchyApps._LaunchyApps[idx].args},
	];

	if (idx >= gLaunchyApps._LaunchyApps.length) {
		launchyShared.trace("Tree and viewer state are out of sync! Help us figure out the problem in bug 119812\nidx: " + idx + " - gLaunchyApps._LaunchyApps.length: " + LaunchyContext.appstype.length, 1);
		return true;
	}

	var field;
	for (var i = 0; i < props.length; i++) {
		field = document.getElementById(props[i].id);
		field.value = props[i].value;
	}
	return true;
}

function LaunchyApp(name, type, exe, args, enabled) {
	this.name = name;
	this.type = type;
	this.exe = exe;
	this.args = args;
	this.enabled = enabled; // 0 = not installed, 1 = installed and active, 2 = installed but disabled
}

function LaunchyApps() {
	this._LaunchyApps = [];
	if (typeof(LaunchyContext.apps) == "undefined") {
		return;
	} else {
		var atomSvc = Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
		this._disabledAtom = atomSvc.getAtom("atomdisabled");
		this._enabledAtom = atomSvc.getAtom("atomenabled");
		for (var j = 0; j < LaunchyContext.apps.length; j++) {
			this.addType(LaunchyContext.apps[j].name, LaunchyContext.apps[j].type, LaunchyContext.apps[j].exe, LaunchyContext.apps[j].args, 1);
		}
		for (j = 0; j < LaunchyContext.appsdisabled.length; j++) {
			this.addType(LaunchyContext.appsdisabled[j].name, LaunchyContext.appsdisabled[j].type, LaunchyContext.appsdisabled[j].exe, LaunchyContext.appsdisabled[j].args, 2);
		}
		for (j = 0; j < LaunchyContext.appsnot.length; j++) {
			this.addType(LaunchyContext.appsnot[j].name, LaunchyContext.appsnot[j].type, LaunchyContext.appsnot[j].exe, LaunchyContext.appsnot[j].args, 0);
		}
	}
}

LaunchyApps.prototype = {
	addType: function (name, type, exe, args, enabled) {
		var pluginType = new LaunchyApp(name, type, exe, args, enabled);
		this._LaunchyApps.push(pluginType);
	},

	cycleCell: function (row, column) {
		switch(column.id || column) {
			case "enabled":
				if (this._LaunchyApps[row].enabled == 1) {
					this._LaunchyApps[row].enabled = 2;
				} else if (this._LaunchyApps[row].enabled == 2) {
					this._LaunchyApps[row].enabled = 1;
				} else {
				}
				gLaunchyAppsList.treeBoxObject.invalidateCell(row, column);
		}
	},

	get rowCount() {
		return this._LaunchyApps.length;
	},

	getCellProperties: function (row, column, aProperties) {
		switch(column.id || column) {
			case "enabled":
			case "name":
				if (this._LaunchyApps[row].exe) {
					if (this._LaunchyApps[row].enabled == 1) {
						aProperties.AppendElement(this._enabledAtom);
					} else if (this._LaunchyApps[row].enabled == 2) {
						aProperties.AppendElement(this._disabledAtom);
					} else {
					}
				}
		}
	},

	getCellText: function (row, column) {
		switch(column.id || column) {
			case "type":
				return LaunchyContext.appstype[this._LaunchyApps[row].type];

			case "name":
				return this._LaunchyApps[row].name;

			default:
				return "";
		}
	},

	getImageSrc: function (row, column) {
		switch(column.id || column) {
			case "name":
				if (this._LaunchyApps[row].exe)
					return "moz-icon:file://" + this._LaunchyApps[row].exe + "?size=16";
				else
					return null;

			default:
				return null;
		}
	},

	selection: null,

	// Stuff we don't need...
	isContainer: function (aRow) { return false; },
	isContainerOpen: function (aRow) { return false; },
	isContainerEmpty: function (aRow) { return true; },
	isSeparator: function (aRow) { return false; },
	isSorted: function () { return false; },
	canDrop: function (aRow, aOrientation) { return false; },
	drop: function (aRow, aOrientation) { },
	getParentIndex: function (aRow) { },
	hasNextSibling: function (aRow, aNextIndex) { },
	getLevel: function (aRow) { },
	getProgressMode: function (aRow, aCol) { },
	getCellValue: function (aRow, aCol) { },
	setTree: function (aTree) { },
	toggleOpenState: function (aRow) { },
	cycleHeader: function (aCol) { },
	selectionChanged: function () { },
	isEditable: function (aRow, aCol) { },
	setCellValue: function (aRow, aCol, aValue) { },
	setCellText: function (aRow, aCol, aValue) { },
	performAction: function (aAction) { },
	performActionOnRow: function (aAction, aRow) { },
	performActionOnCell: function (aAction, aRow, aCol) { },
	getRowProperties: function (aRow, aProperties) { },
	getColumnProperties: function (aCol, aProperties) { }
};
